import { world, system, BlockPermutation, Dimension } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  const oldBlockNames = [
    "nicothekid:jar_of_forest_wisp_charged_block",
    "nicothekid:jar_of_forest_wisp_uncharged_block",
    "nicothekid:jar_of_moss_berry_cookies_1_block",
    "nicothekid:jar_of_moss_berry_cookies_2_block",
    "nicothekid:jar_of_moss_berry_cookies_3_block",
    "nicothekid:jar_of_moss_berry_cookies_4_block",
    "nicothekid:jar_of_moss_berry_cookies_5_block",
    "nicothekid:jar_of_moss_berry_cookies_6_block",
    "nicothekid:jar_of_moss_berry_cookies_7_block",
    "nicothekid:jar_of_moss_berry_cookies_8_block",
    "nicothekid:lush_grass_bale",
    "nicothekid:potted_lush_grass",
    "nicothekid:short_lush_grass_block",
    "nicothekid:tall_lush_grass_block",
    "nicothekid:wild_beetroot_block",
    "nicothekid:wild_carrot_block",
    "nicothekid:wild_potato_block",
    "nicothekid:wild_wheat_block"
  ]
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:block_updating_fo_on_tick", {
    onTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      const blockState = block.permutation.getState("minecraft:cardinal_direction");
      const blockAllState = block.permutation.getAllStates();
      if (oldBlockNames.includes(block.typeId)) {
        if (block.permutation.matches("nicothekid:jar_of_forest_wisp_charged_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_forest_wisp_charged", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_forest_wisp_uncharged_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_forest_wisp_uncharged", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_moss_berry_cookies_1_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_moss_berry_cookies_1", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_moss_berry_cookies_2_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_moss_berry_cookies_2", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_moss_berry_cookies_3_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_moss_berry_cookies_3", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_moss_berry_cookies_4_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_moss_berry_cookies_4", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_moss_berry_cookies_5_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_moss_berry_cookies_5", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_moss_berry_cookies_6_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_moss_berry_cookies_6", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_moss_berry_cookies_7_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_moss_berry_cookies_7", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_moss_berry_cookies_8_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_moss_berry_cookies_8", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:lush_grass_bale")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:lush_bush_bale", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:potted_lush_grass")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:potted_lush_bush"));
          return;
        }
        if (block.permutation.matches("nicothekid:short_lush_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:short_lush_bush"));
          return;
        }
        if (block.permutation.matches("nicothekid:tall_lush_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:tall_lush_bush"));
          return;
        }
        if (block.permutation.matches("nicothekid:wild_beetroot_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:wild_beetroot"));
          return;
        }
        if (block.permutation.matches("nicothekid:wild_carrot_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:wild_carrot"));
          return;
        }
        if (block.permutation.matches("nicothekid:wild_potato_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:wild_potato"));
          return;
        }
        if (block.permutation.matches("nicothekid:wild_wheat_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:wild_wheat"));
          return;
        }
      }
      else return;
    }
  });
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:block_updating_fo_on_random_tick", {
    onRandomTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      const blockState = block.permutation.getState("minecraft:cardinal_direction");
      const blockAllState = block.permutation.getAllStates();
      if (oldBlockNames.includes(block.typeId)) {
        if (block.permutation.matches("nicothekid:jar_of_forest_wisp_charged_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_forest_wisp_charged", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_forest_wisp_uncharged_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_forest_wisp_uncharged", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_moss_berry_cookies_1_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_moss_berry_cookies_1", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_moss_berry_cookies_2_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_moss_berry_cookies_2", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_moss_berry_cookies_3_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_moss_berry_cookies_3", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_moss_berry_cookies_4_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_moss_berry_cookies_4", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_moss_berry_cookies_5_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_moss_berry_cookies_5", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_moss_berry_cookies_6_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_moss_berry_cookies_6", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_moss_berry_cookies_7_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_moss_berry_cookies_7", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_moss_berry_cookies_8_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_moss_berry_cookies_8", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:lush_grass_bale")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:lush_bush_bale", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:potted_lush_grass")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:potted_lush_bush"));
          return;
        }
        if (block.permutation.matches("nicothekid:short_lush_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:short_lush_bush"));
          return;
        }
        if (block.permutation.matches("nicothekid:tall_lush_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:tall_lush_bush"));
          return;
        }
        if (block.permutation.matches("nicothekid:wild_beetroot_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:wild_beetroot"));
          return;
        }
        if (block.permutation.matches("nicothekid:wild_carrot_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:wild_carrot"));
          return;
        }
        if (block.permutation.matches("nicothekid:wild_potato_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:wild_potato"));
          return;
        }
        if (block.permutation.matches("nicothekid:wild_wheat_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:wild_wheat"));
          return;
        }
      }
      else return;
    }
  });
});