import { world, system, BlockPermutation, Dimension } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  const oldBlockNames = [
    "nicothekid:blue_tip_grass_block",
    "nicothekid:light_blue_tip_grass_block",
    "nicothekid:magenta_tip_grass_block",
    "nicothekid:orange_tip_grass_block",
    "nicothekid:pink_tip_grass_block",
    "nicothekid:red_tip_grass_block",
    "nicothekid:white_tip_grass_block",
    "nicothekid:yellow_tip_grass_block"
  ]
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:block_updating_nbe_on_tick", {
    onTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      const blockState = block.permutation.getState("minecraft:cardinal_direction");
      const blockAllState = block.permutation.getAllStates();
      if (oldBlockNames.includes(block.typeId)) {
        if (block.permutation.matches("nicothekid:blue_tip_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:blue_tip_grass"));
          return;
        }
        if (block.permutation.matches("nicothekid:light_blue_tip_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:light_blue_tip_grass"));
          return;
        }
        if (block.permutation.matches("nicothekid:magenta_tip_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:magenta_tip_grass"));
          return;
        }
        if (block.permutation.matches("nicothekid:orange_tip_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:orange_tip_grass"));
          return;
        }
        if (block.permutation.matches("nicothekid:pink_tip_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:pink_tip_grass"));
          return;
        }
        if (block.permutation.matches("nicothekid:red_tip_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:red_tip_grass"));
          return;
        }
        if (block.permutation.matches("nicothekid:white_tip_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:white_tip_grass"));
          return;
        }
        if (block.permutation.matches("nicothekid:yellow_tip_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:yellow_tip_grass"));
          return;
        }
      }
      else return;
    }
  });
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:block_updating_nbe_on_random_tick", {
    onRandomTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      const blockState = block.permutation.getState("minecraft:cardinal_direction");
      const blockAllState = block.permutation.getAllStates();
      if (oldBlockNames.includes(block.typeId)) {
        if (block.permutation.matches("nicothekid:blue_tip_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:blue_tip_grass"));
          return;
        }
        if (block.permutation.matches("nicothekid:light_blue_tip_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:light_blue_tip_grass"));
          return;
        }
        if (block.permutation.matches("nicothekid:magenta_tip_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:magenta_tip_grass"));
          return;
        }
        if (block.permutation.matches("nicothekid:orange_tip_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:orange_tip_grass"));
          return;
        }
        if (block.permutation.matches("nicothekid:pink_tip_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:pink_tip_grass"));
          return;
        }
        if (block.permutation.matches("nicothekid:red_tip_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:red_tip_grass"));
          return;
        }
        if (block.permutation.matches("nicothekid:white_tip_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:white_tip_grass"));
          return;
        }
        if (block.permutation.matches("nicothekid:yellow_tip_grass_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:yellow_tip_grass"));
          return;
        }
      }
      else return;
    }
  });
});