import { world, system, BlockPermutation, Dimension } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  const oldBlockNames = [
    "nicothekid:glowceling_egg_block",
    "nicothekid:mosshroom_fungus_block",
    "nicothekid:myceling_egg_block",
    "nicothekid:quartz_cluster_block",
    "nicothekid:quartz_cluster_block_down",
    "nicothekid:rose_quartz_cluster_block",
    "nicothekid:rose_quartz_cluster_block_down",
    "nicothekid:short_mycelium_sprouts_block",
    "nicothekid:tall_glowcelium_sprouts_block",
    "nicothekid:tall_mycelium_sprouts_block"
  ]
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:block_updating_nce_on_tick", {
    onTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      const blockState = block.permutation.getState("minecraft:cardinal_direction");
      const blockAllState = block.permutation.getAllStates();
      if (oldBlockNames.includes(block.typeId)) {
        if (block.permutation.matches("nicothekid:glowceling_egg_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:glowceling_egg"));
          return;
        }
        if (block.permutation.matches("nicothekid:mosshroom_fungus_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:mosshroom_fungus"));
          return;
        }
        if (block.permutation.matches("nicothekid:myceling_egg_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:myceling_egg"));
          return;
        }
        if (block.permutation.matches("nicothekid:quartz_cluster_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:quartz_cluster", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:quartz_cluster_block_down")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:quartz_cluster", { "minecraft:block_face": "up" }));
          return;
        }
        if (block.permutation.matches("nicothekid:rose_quartz_cluster_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:rose_quartz_cluster", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:rose_quartz_cluster_block_down")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:rose_quartz_cluster", { "minecraft:block_face": "up" }));
          return;
        }
        if (block.permutation.matches("nicothekid:short_mycelium_sprouts_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:short_mycelium_sprouts"));
          return;
        }
        if (block.permutation.matches("nicothekid:tall_glowcelium_sprouts_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:tall_glowcelium_sprouts", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:tall_mycelium_sprouts_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:tall_mycelium_sprouts", blockAllState ));
          return;
        }
      }
      else return;
    }
  });
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:block_updating_nce_on_random_tick", {
    onRandomTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      const blockState = block.permutation.getState("minecraft:cardinal_direction");
      const blockAllState = block.permutation.getAllStates();
      if (oldBlockNames.includes(block.typeId)) {
        if (block.permutation.matches("nicothekid:glowceling_egg_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:glowceling_egg"));
          return;
        }
        if (block.permutation.matches("nicothekid:mosshroom_fungus_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:mosshroom_fungus"));
          return;
        }
        if (block.permutation.matches("nicothekid:myceling_egg_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:myceling_egg"));
          return;
        }
        if (block.permutation.matches("nicothekid:quartz_cluster_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:quartz_cluster", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:quartz_cluster_block_down")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:quartz_cluster", { "minecraft:block_face": "up" }));
          return;
        }
        if (block.permutation.matches("nicothekid:rose_quartz_cluster_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:rose_quartz_cluster", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:rose_quartz_cluster_block_down")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:rose_quartz_cluster", { "minecraft:block_face": "up" }));
          return;
        }
        if (block.permutation.matches("nicothekid:short_mycelium_sprouts_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:short_mycelium_sprouts"));
          return;
        }
        if (block.permutation.matches("nicothekid:tall_glowcelium_sprouts_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:tall_glowcelium_sprouts", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:tall_mycelium_sprouts_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:tall_mycelium_sprouts", blockAllState ));
          return;
        }
      }
      else return;
    }
  });
});