import { world, system, BlockPermutation, Dimension } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  const oldBlockNames = [
    "nicothekid:bamboo_tumbler_with_chocolate_block",
    "nicothekid:bamboo_tumbler_with_glow_berry_juice_block",
    "nicothekid:bamboo_tumbler_with_milk_block",
    "nicothekid:bamboo_tumbler_with_sweet_berry_juice_block",
    "nicothekid:bamboo_tumbler_with_water_block",
    "nicothekid:copper_chain_block",
    "nicothekid:empty_bamboo_tumbler_block",
    "nicothekid:empty_jar_block",
    "nicothekid:golden_chain_block",
    "nicothekid:jar_of_chocolate_full_block",
    "nicothekid:jar_of_chocolate_half_block",
    "nicothekid:jar_of_cookies_1_block",
    "nicothekid:jar_of_cookies_2_block",
    "nicothekid:jar_of_cookies_3_block",
    "nicothekid:jar_of_cookies_4_block",
    "nicothekid:jar_of_cookies_5_block",
    "nicothekid:jar_of_cookies_6_block",
    "nicothekid:jar_of_cookies_7_block",
    "nicothekid:jar_of_cookies_8_block",
    "nicothekid:jar_of_glow_berry_cookies_1_block",
    "nicothekid:jar_of_glow_berry_cookies_2_block",
    "nicothekid:jar_of_glow_berry_cookies_3_block",
    "nicothekid:jar_of_glow_berry_cookies_4_block",
    "nicothekid:jar_of_glow_berry_cookies_5_block",
    "nicothekid:jar_of_glow_berry_cookies_6_block",
    "nicothekid:jar_of_glow_berry_cookies_7_block",
    "nicothekid:jar_of_glow_berry_cookies_8_block",
    "nicothekid:jar_of_glow_berry_juice_full_block",
    "nicothekid:jar_of_glow_berry_juice_half_block",
    "nicothekid:jar_of_honey_full_block",
    "nicothekid:jar_of_honey_half_block",
    "nicothekid:jar_of_milk_full_block",
    "nicothekid:jar_of_milk_half_block",
    "nicothekid:jar_of_sweet_berry_cookies_1_block",
    "nicothekid:jar_of_sweet_berry_cookies_2_block",
    "nicothekid:jar_of_sweet_berry_cookies_3_block",
    "nicothekid:jar_of_sweet_berry_cookies_4_block",
    "nicothekid:jar_of_sweet_berry_cookies_5_block",
    "nicothekid:jar_of_sweet_berry_cookies_6_block",
    "nicothekid:jar_of_sweet_berry_cookies_7_block",
    "nicothekid:jar_of_sweet_berry_cookies_8_block",
    "nicothekid:jar_of_sweet_berry_juice_full_block",
    "nicothekid:jar_of_sweet_berry_juice_half_block",
    "nicothekid:jar_of_water_full_block",
    "nicothekid:jar_of_water_half_block"
  ]
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:block_updating_nie_on_tick", {
    onTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      const blockState = block.permutation.getState("minecraft:cardinal_direction");
      const blockAllState = block.permutation.getAllStates();
      if (oldBlockNames.includes(block.typeId)) {
        if (block.permutation.matches("nicothekid:bamboo_tumbler_with_chocolate_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:bamboo_tumbler_with_chocolate"));
          return;
        }
        if (block.permutation.matches("nicothekid:bamboo_tumbler_with_glow_berry_juice_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:bamboo_tumbler_with_glow_berry_juice"));
          return;
        }
        if (block.permutation.matches("nicothekid:bamboo_tumbler_with_milk_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:bamboo_tumbler_with_milk"));
          return;
        }
        if (block.permutation.matches("nicothekid:bamboo_tumbler_with_sweet_berry_juice_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:bamboo_tumbler_with_sweet_berry_juice"));
          return;
        }
        if (block.permutation.matches("nicothekid:bamboo_tumbler_with_water_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:bamboo_tumbler_with_water"));
          return;
        }
        if (block.permutation.matches("nicothekid:copper_chain_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:copper_chain", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:empty_bamboo_tumbler_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:empty_bamboo_tumbler"));
          return;
        }
        if (block.permutation.matches("nicothekid:empty_jar_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:empty_jar", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:golden_chain_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:golden_chain", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_chocolate_full_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_chocolate_full", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_chocolate_half_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_chocolate_half", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_cookies_1_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_cookies_1", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_cookies_2_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_cookies_2", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_cookies_3_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_cookies_3", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_cookies_4_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_cookies_4", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_cookies_5_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_cookies_5", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_cookies_6_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_cookies_6", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_cookies_7_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_cookies_7", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_cookies_8_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_cookies_8", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_glow_berry_cookies_1_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_glow_berry_cookies_1", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_glow_berry_cookies_2_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_glow_berry_cookies_2", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_glow_berry_cookies_3_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_glow_berry_cookies_3", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_glow_berry_cookies_4_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_glow_berry_cookies_4", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_glow_berry_cookies_5_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_glow_berry_cookies_5", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_glow_berry_cookies_6_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_glow_berry_cookies_6", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_glow_berry_cookies_7_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_glow_berry_cookies_7", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_glow_berry_cookies_8_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_glow_berry_cookies_8", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_glow_berry_juice_full_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_glow_berry_juice_full", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_glow_berry_juice_half_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_glow_berry_juice_half", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_honey_full_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_honey_full", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_honey_half_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_honey_half", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_milk_full_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_milk_full", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_milk_half_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_milk_half", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_sweet_berry_cookies_1_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_sweet_berry_cookies_1", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_sweet_berry_cookies_2_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_sweet_berry_cookies_2", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_sweet_berry_cookies_3_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_sweet_berry_cookies_3", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_sweet_berry_cookies_4_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_sweet_berry_cookies_4", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_sweet_berry_cookies_5_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_sweet_berry_cookies_5", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_sweet_berry_cookies_6_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_sweet_berry_cookies_6", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_sweet_berry_cookies_7_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_sweet_berry_cookies_7", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_sweet_berry_cookies_8_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_sweet_berry_cookies_8", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_sweet_berry_juice_full_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_sweet_berry_juice_full", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_sweet_berry_juice_half_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_sweet_berry_juice_half", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_water_full_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_water_full", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_water_half_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_water_half", blockAllState ));
          return;
        }
      }
      else return;
    }
  });
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:block_updating_nie_on_random_tick", {
    onRandomTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      const blockState = block.permutation.getState("minecraft:cardinal_direction");
      const blockAllState = block.permutation.getAllStates();
      if (oldBlockNames.includes(block.typeId)) {
        if (block.permutation.matches("nicothekid:bamboo_tumbler_with_chocolate_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:bamboo_tumbler_with_chocolate"));
          return;
        }
        if (block.permutation.matches("nicothekid:bamboo_tumbler_with_glow_berry_juice_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:bamboo_tumbler_with_glow_berry_juice"));
          return;
        }
        if (block.permutation.matches("nicothekid:bamboo_tumbler_with_milk_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:bamboo_tumbler_with_milk"));
          return;
        }
        if (block.permutation.matches("nicothekid:bamboo_tumbler_with_sweet_berry_juice_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:bamboo_tumbler_with_sweet_berry_juice"));
          return;
        }
        if (block.permutation.matches("nicothekid:bamboo_tumbler_with_water_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:bamboo_tumbler_with_water"));
          return;
        }
        if (block.permutation.matches("nicothekid:copper_chain_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:copper_chain", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:empty_bamboo_tumbler_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:empty_bamboo_tumbler"));
          return;
        }
        if (block.permutation.matches("nicothekid:empty_jar_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:empty_jar", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:golden_chain_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:golden_chain", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_chocolate_full_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_chocolate_full", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_chocolate_half_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_chocolate_half", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_cookies_1_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_cookies_1", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_cookies_2_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_cookies_2", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_cookies_3_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_cookies_3", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_cookies_4_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_cookies_4", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_cookies_5_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_cookies_5", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_cookies_6_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_cookies_6", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_cookies_7_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_cookies_7", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_cookies_8_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_cookies_8", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_glow_berry_cookies_1_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_glow_berry_cookies_1", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_glow_berry_cookies_2_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_glow_berry_cookies_2", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_glow_berry_cookies_3_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_glow_berry_cookies_3", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_glow_berry_cookies_4_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_glow_berry_cookies_4", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_glow_berry_cookies_5_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_glow_berry_cookies_5", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_glow_berry_cookies_6_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_glow_berry_cookies_6", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_glow_berry_cookies_7_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_glow_berry_cookies_7", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_glow_berry_cookies_8_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_glow_berry_cookies_8", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_glow_berry_juice_full_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_glow_berry_juice_full", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_glow_berry_juice_half_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_glow_berry_juice_half", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_honey_full_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_honey_full", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_honey_half_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_honey_half", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_milk_full_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_milk_full", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_milk_half_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_milk_half", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_sweet_berry_cookies_1_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_sweet_berry_cookies_1", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_sweet_berry_cookies_2_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_sweet_berry_cookies_2", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_sweet_berry_cookies_3_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_sweet_berry_cookies_3", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_sweet_berry_cookies_4_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_sweet_berry_cookies_4", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_sweet_berry_cookies_5_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_sweet_berry_cookies_5", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_sweet_berry_cookies_6_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_sweet_berry_cookies_6", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_sweet_berry_cookies_7_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_sweet_berry_cookies_7", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_sweet_berry_cookies_8_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_sweet_berry_cookies_8", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_sweet_berry_juice_full_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_sweet_berry_juice_full", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_sweet_berry_juice_half_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_sweet_berry_juice_half", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_water_full_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_water_full", blockAllState ));
          return;
        }
        if (block.permutation.matches("nicothekid:jar_of_water_half_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:jar_of_water_half", blockAllState ));
          return;
        }
      }
      else return;
    }
  });
});