import { world, system, BlockPermutation, Dimension } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  const oldBlockNames = [
    "nicothekid:moa_egg_block"
  ]
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:block_updating_nm_on_tick", {
    onTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      const blockState = block.permutation.getState("minecraft:cardinal_direction");
      const blockAllState = block.permutation.getAllStates();
      if (oldBlockNames.includes(block.typeId)) {
        if (block.permutation.matches("nicothekid:moa_egg_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:moa_egg"));
          return;
        }
      }
      else return;
    }
  });
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:block_updating_nm_on_random_tick", {
    onRandomTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      const blockState = block.permutation.getState("minecraft:cardinal_direction");
      const blockAllState = block.permutation.getAllStates();
      if (oldBlockNames.includes(block.typeId)) {
        if (block.permutation.matches("nicothekid:moa_egg_block")) {
          block.setPermutation(BlockPermutation.resolve("nicothekid:moa_egg"));
          return;
        }
      }
      else return;
    }
  });
});