import { world, system, BlockPermutation, Dimension, ItemStack, GameMode } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent("nicothekid:blue_tip_grass_on_use_on", {
    onUseOn: eventData => {
      const player = eventData.source;
      const itemUsed = eventData.itemStack;
      const block = eventData.block;
      const playerEquippable = player.getComponent("equippable");
      function decreaseItem () {
        system.run(() => {
          if (!player.matches({ gameMode: GameMode.creative })) {
            const decrementItem = itemUsed.amount == 1 ? undefined : (itemUsed.amount--, itemUsed);
            playerEquippable.setEquipment("Mainhand", decrementItem)
          }
        });
      }
      if (player.isSneaking) return;
      if (itemUsed.typeId === "nicothekid:blue_tip_grass") {
        system.run(() => {
          if (block.typeId === "minecraft:flower_pot") {
            decreaseItem ();
            block.setPermutation(BlockPermutation.resolve("nicothekid:potted_blue_tip_grass"));
          }
        });
      }
    }
  });
  initEvent.itemComponentRegistry.registerCustomComponent("nicothekid:light_blue_tip_grass_on_use_on", {
    onUseOn: eventData => {
      const player = eventData.source;
      const itemUsed = eventData.itemStack;
      const block = eventData.block;
      const playerEquippable = player.getComponent("equippable");
      function decreaseItem () {
        system.run(() => {
          if (!player.matches({ gameMode: GameMode.creative })) {
            const decrementItem = itemUsed.amount == 1 ? undefined : (itemUsed.amount--, itemUsed);
            playerEquippable.setEquipment("Mainhand", decrementItem)
          }
        });
      }
      if (player.isSneaking) return;
      if (itemUsed.typeId === "nicothekid:light_blue_tip_grass") {
        system.run(() => {
          if (block.typeId === "minecraft:flower_pot") {
            decreaseItem ();
            block.setPermutation(BlockPermutation.resolve("nicothekid:potted_light_blue_tip_grass"));
          }
        });
      }
    }
  });
  initEvent.itemComponentRegistry.registerCustomComponent("nicothekid:magenta_tip_grass_on_use_on", {
    onUseOn: eventData => {
      const player = eventData.source;
      const itemUsed = eventData.itemStack;
      const block = eventData.block;
      const playerEquippable = player.getComponent("equippable");
      function decreaseItem () {
        system.run(() => {
          if (!player.matches({ gameMode: GameMode.creative })) {
            const decrementItem = itemUsed.amount == 1 ? undefined : (itemUsed.amount--, itemUsed);
            playerEquippable.setEquipment("Mainhand", decrementItem)
          }
        });
      }
      if (player.isSneaking) return;
      if (itemUsed.typeId === "nicothekid:magenta_tip_grass") {
        system.run(() => {
          if (block.typeId === "minecraft:flower_pot") {
            decreaseItem ();
            block.setPermutation(BlockPermutation.resolve("nicothekid:potted_magenta_tip_grass"));
          }
        });
      }
    }
  });
  initEvent.itemComponentRegistry.registerCustomComponent("nicothekid:orange_tip_grass_on_use_on", {
    onUseOn: eventData => {
      const player = eventData.source;
      const itemUsed = eventData.itemStack;
      const block = eventData.block;
      const playerEquippable = player.getComponent("equippable");
      function decreaseItem () {
        system.run(() => {
          if (!player.matches({ gameMode: GameMode.creative })) {
            const decrementItem = itemUsed.amount == 1 ? undefined : (itemUsed.amount--, itemUsed);
            playerEquippable.setEquipment("Mainhand", decrementItem)
          }
        });
      }
      if (player.isSneaking) return;
      if (itemUsed.typeId === "nicothekid:orange_tip_grass") {
        system.run(() => {
          if (block.typeId === "minecraft:flower_pot") {
            decreaseItem ();
            block.setPermutation(BlockPermutation.resolve("nicothekid:potted_orange_tip_grass"));
          }
        });
      }
    }
  });
  initEvent.itemComponentRegistry.registerCustomComponent("nicothekid:pink_tip_grass_on_use_on", {
    onUseOn: eventData => {
      const player = eventData.source;
      const itemUsed = eventData.itemStack;
      const block = eventData.block;
      const playerEquippable = player.getComponent("equippable");
      function decreaseItem () {
        system.run(() => {
          if (!player.matches({ gameMode: GameMode.creative })) {
            const decrementItem = itemUsed.amount == 1 ? undefined : (itemUsed.amount--, itemUsed);
            playerEquippable.setEquipment("Mainhand", decrementItem)
          }
        });
      }
      if (player.isSneaking) return;
      if (itemUsed.typeId === "nicothekid:pink_tip_grass") {
        system.run(() => {
          if (block.typeId === "minecraft:flower_pot") {
            decreaseItem ();
            block.setPermutation(BlockPermutation.resolve("nicothekid:potted_pink_tip_grass"));
          }
        });
      }
    }
  });
  initEvent.itemComponentRegistry.registerCustomComponent("nicothekid:red_tip_grass_on_use_on", {
    onUseOn: eventData => {
      const player = eventData.source;
      const itemUsed = eventData.itemStack;
      const block = eventData.block;
      const playerEquippable = player.getComponent("equippable");
      function decreaseItem () {
        system.run(() => {
          if (!player.matches({ gameMode: GameMode.creative })) {
            const decrementItem = itemUsed.amount == 1 ? undefined : (itemUsed.amount--, itemUsed);
            playerEquippable.setEquipment("Mainhand", decrementItem)
          }
        });
      }
      if (player.isSneaking) return;
      if (itemUsed.typeId === "nicothekid:red_tip_grass") {
        system.run(() => {
          if (block.typeId === "minecraft:flower_pot") {
            decreaseItem ();
            block.setPermutation(BlockPermutation.resolve("nicothekid:potted_red_tip_grass"));
          }
        });
      }
    }
  });
  initEvent.itemComponentRegistry.registerCustomComponent("nicothekid:white_tip_grass_on_use_on", {
    onUseOn: eventData => {
      const player = eventData.source;
      const itemUsed = eventData.itemStack;
      const block = eventData.block;
      const playerEquippable = player.getComponent("equippable");
      function decreaseItem () {
        system.run(() => {
          if (!player.matches({ gameMode: GameMode.creative })) {
            const decrementItem = itemUsed.amount == 1 ? undefined : (itemUsed.amount--, itemUsed);
            playerEquippable.setEquipment("Mainhand", decrementItem)
          }
        });
      }
      if (player.isSneaking) return;
      if (itemUsed.typeId === "nicothekid:white_tip_grass") {
        system.run(() => {
          if (block.typeId === "minecraft:flower_pot") {
            decreaseItem ();
            block.setPermutation(BlockPermutation.resolve("nicothekid:potted_white_tip_grass"));
          }
        });
      }
    }
  });
  initEvent.itemComponentRegistry.registerCustomComponent("nicothekid:yellow_tip_grass_on_use_on", {
    onUseOn: eventData => {
      const player = eventData.source;
      const itemUsed = eventData.itemStack;
      const block = eventData.block;
      const playerEquippable = player.getComponent("equippable");
      function decreaseItem () {
        system.run(() => {
          if (!player.matches({ gameMode: GameMode.creative })) {
            const decrementItem = itemUsed.amount == 1 ? undefined : (itemUsed.amount--, itemUsed);
            playerEquippable.setEquipment("Mainhand", decrementItem)
          }
        });
      }
      if (player.isSneaking) return;
      if (itemUsed.typeId === "nicothekid:yellow_tip_grass") {
        system.run(() => {
          if (block.typeId === "minecraft:flower_pot") {
            decreaseItem ();
            block.setPermutation(BlockPermutation.resolve("nicothekid:potted_yellow_tip_grass"));
          }
        });
      }
    }
  });
});