import { world, BlockPermutation, ItemStack, GameMode } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  const tipGrasses = [
    "nicothekid:blue_tip_grass",
    "nicothekid:light_blue_tip_grass",
    "nicothekid:magenta_tip_grass",
    "nicothekid:orange_tip_grass",
    "nicothekid:pink_tip_grass",
    "nicothekid:red_tip_grass",
    "nicothekid:white_tip_grass",
    "nicothekid:yellow_tip_grass"
  ]
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:tip_grass_on_player_destroy", {
    onPlayerDestroy: eventData => {
      const player = eventData.player;
      const destroyedBlock = eventData.destroyedBlockPermutation;
      const block = eventData.block;
      const blockLocation = block.location;
      const playerEquippable = player.getComponent("equippable");
      const itemUsed = playerEquippable.getEquipment("Mainhand");
      if (player.matches({ gameMode: GameMode.creative })) return;
      if (tipGrasses.includes(destroyedBlock.type.id)) {
        if (itemUsed === undefined) {
          return;
        }
        else {
          if (itemUsed.typeId === "minecraft:shears" || itemUsed.hasTag("minecraft:is_shears")) {
            if (destroyedBlock.type.id === "nicothekid:blue_tip_grass") {
              const spawnBlueTipGrass = new ItemStack ("nicothekid:blue_tip_grass", 1);
              block.dimension.spawnItem(spawnBlueTipGrass, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
            }
            if (destroyedBlock.type.id === "nicothekid:light_blue_tip_grass") {
              const spawnLightBlueTipGrass = new ItemStack ("nicothekid:light_blue_tip_grass", 1);
              block.dimension.spawnItem(spawnLightBlueTipGrass, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
            }
            if (destroyedBlock.type.id === "nicothekid:magenta_tip_grass") {
              const spawnMagentaTipGrass = new ItemStack ("nicothekid:magenta_tip_grass", 1);
              block.dimension.spawnItem(spawnMagentaTipGrass, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
            }
            if (destroyedBlock.type.id === "nicothekid:orange_tip_grass") {
              const spawnOrangeTipGrass = new ItemStack ("nicothekid:orange_tip_grass", 1);
              block.dimension.spawnItem(spawnOrangeTipGrass, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
            }
            if (destroyedBlock.type.id === "nicothekid:pink_tip_grass") {
              const spawnPinkTipGrass = new ItemStack ("nicothekid:pink_tip_grass", 1);
              block.dimension.spawnItem(spawnPinkTipGrass, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
            }
            if (destroyedBlock.type.id === "nicothekid:red_tip_grass") {
              const spawnRedTipGrass = new ItemStack ("nicothekid:red_tip_grass", 1);
              block.dimension.spawnItem(spawnRedTipGrass, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
            }
            if (destroyedBlock.type.id === "nicothekid:white_tip_grass") {
              const spawnWhiteTipGrass = new ItemStack ("nicothekid:white_tip_grass", 1);
              block.dimension.spawnItem(spawnWhiteTipGrass, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
            }
            if (destroyedBlock.type.id === "nicothekid:yellow_tip_grass") {
              const spawnYellowTipGrass = new ItemStack ("nicothekid:yellow_tip_grass", 1);
              block.dimension.spawnItem(spawnYellowTipGrass, { x: blockLocation.x + 0.5, y: blockLocation.y + 0.5, z: blockLocation.z + 0.5 });
            }
          }
          else return;
        }
      }
      else return;
    }
  });
})
